import sql from "./sql.js";

let cfg = {
  client: {},
  main: {},
  websrv: {},
  trigger: {}
};

const read = () => new Promise((resolve, reject) => {
  sql.exec("select * from `cfg`", (err, rows) => {
    if(err || rows.length < 1)
      reject({ error: "no cfg" });
    else {
      for(let row in rows) {
        cfg[rows[row].class][rows[row].key] = ((type, value) => {
          switch(type) {
          case "string":
            return value;
          case "int":
            return parseInt(value);
          case "bool":
            return value === "true";
          case "json":
            return JSON.parse(value);
          }
        })(rows[row].type, rows[row].value);
      }
      resolve();
    }
  });
});

export { cfg, read };